#############################################################################
#
# Package: The Invar Tensor Package
#
# Language for this test: Maple.
#
# Description: Test file.
#
# Developers: Renato Portugal
#             Laboratorio Nacional de Computacao Cientifica (LNCC)
#                            and
#             Jose Maria Martin-Garcia
#             Consejo Superior de Investigaciones Cientificas (CSIC)
#
# Web page: http://www.lnc.br/~portugal/Canon.html
#
# Contact and bug report: Portugal@Lncc.Br
#
#############################################################################

# RiemannSimplify

expr1 := epsilon[a,b,c,d]*Riemann[-a,-b,e,f]*Riemann[-c,-e,-f,g]*Riemann[-d,h,i,j]*Ricci[-g,-i]*Ricci[-h,-j]+1/8*(epsilon[a,b,c,d]*Riemann[-a,-b,e,f]*Riemann[-c,-d,-e,-f])*(Riemann[g,h,i,j]*Ricci[-g,-i]*Ricci[-h,-j]):

expr2 := Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,-a3,a5]*Riemann[-a4,a6,a7,a8]*epsilon[-a5,-a6,-a7,-a8]:

expr3 := Riemann[a1,a2,a3,-a1]*Riemann[-a3,a5,-a2,a4]*Riemann[-a4,a6,a8,a7]*epsilon[-a5,-a7,-a8,-a6]:

expr4 := Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,a5,a6]*Riemann[-a3,-a4,a7,a8]*Riemann[-a5,b0,-b0,a9]*epsilon[-a6,-a7,-a8,-a9]+1/2*Riemann[a11,a22,-a11,-a22]*Riemann[a1,a2,-a1,a3]*Riemann[-a2,a4,a5,a6]*Riemann[-a4,a7,-a7,a8]*epsilon[-a3,-a5,-a6,-a8]-1/16*Riemann[a10,a20,-a10,-a20]*Riemann[a11,a22,-a11,-a22]*Riemann[a1,a2,a3,a4]*Riemann[-a1,-a2,a5,a6]*epsilon[-a3,-a4,-a5,-a6]:

expr5 := -Ricci[-a2,a3]*Ricci[a5,a2]*Riemann[-a3,a6,a7,a8]*Riemann[-a5,-a7,-a6,b0]*Ricci[-a8,-b0]+5/24*RicciS[]^5+49/24*RicciS[]^2*Ricci[a3,-a2]*Ricci[a2,a5]*Ricci[-a5,-a3]+Ricci[a2,a3]*Riemann[-a2,a4,-a3,a5]*Riemann[-a4,a6,-a5,a7]*Ricci[-a6,b0]*Ricci[-a7,-b0]+1/24*RicciS[]^3*Riemann[a1,a2,a3,a4]*Riemann[-a1,-a2,-a3,-a4]-5/4*RicciS[]*Ricci[a2,a3]*Ricci[-a2,a5]*Ricci[-a3,a7]*Ricci[-a5,-a7]+3/4*RicciS[]^2*Ricci[a2,a3]*Riemann[-a2,a4,-a3,a5]*Ricci[-a4,-a5]-13/8*RicciS[]^3*Ricci[a2,a3]*Ricci[-a2,-a3]-1/2*RicciS[]*Ricci[a2,-a3]*Riemann[-a2,a4,a5,a6]*Riemann[a7,a3,-a6,-a5]*Ricci[-a4,-a7]-1/24*Riemann[a3,a4,a1,a2]*Riemann[-a1,-a2,-a3,-a4]*Ricci[a20,a30]*Ricci[-a20,a50]*Ricci[-a30,-a50]+5/8*RicciS[]*Ricci[a2,a3]*Ricci[-a2,-a3]*Ricci[a20,a30]*Ricci[-a20,-a30]:

# cyclic symmetries

expr6 := RInv[2,3] - 1/2*RInv[2,2] - RInv[3,6] + 1/2*RInv[3,5]:

expr7 := - RInv[4,38] + 1/4*RInv[4,23]-RInv[4,26]+RInv[4,36]:

expr8 := RInv[6,31] -RInv[5,203] -RInv[5,200]+RInv[5,201] - 1/4*RInv[6,27]:

expr9 := - RInv[6,1575] + 3/4*RInv[6,1219]+1/2*RInv[6,1223]+RInv[6,1572]-3/2*RInv[6,1221]:

expr10 := RInv[7,15138] - 1/2*RInv[7,12749] - RInv[6,1524] + RInv[6,1523]-1/2*RInv[6,1161]:

expr11 := -RInv[7,16207] -1/4*RInv[7,12848]+RInv[7,16206]:

expr12 := -RInv[7,16467] -RInv[7,16383]-4*RInv[7,16269]-RInv[7,16280]-RInv[7,16306]-3*RInv[7,16262]+3*RInv[7,16281]+4*RInv[7,16263]+RInv[7,16265]+RInv[7,16268]-3*RInv[7,16318]-RInv[7,16325]+2*RInv[7,16292]-2*RInv[7,16341]:

expr13 := DualRInv[2,1]+DualRInv[3,1]:

expr14 := - DualRInv[3,27] -1/4*DualRInv[3,14]+1/2*DualRInv[3,23] + DualRInv[4,1] - DualRInv[4,3] + 1/2*DualRInv[4,2] -7*DualRInv[4,9] + DualRInv[4,11] - 1/2*DualRInv[4,10]:

expr15 := DualRInv[4,231] + DualRInv[4,232] + DualRInv[5,1] + DualRInv[5,3] - 1/2*DualRInv[5,2] + 10*DualRInv[5,8] + DualRInv[5,9] - DualRInv[5,10]:

expr16 := - DualRInv[5,2560] + 2*DualRInv[5,2505]-DualRInv[5,2507]-DualRInv[5,2551]:

# dimension dependent relations

expr17 := - RInv[3,3] + 1/4*RInv[1,1]^3-2*RInv[3,1]+1/4*RInv[1,1]*RInv[2,2]+2*RInv[3,2]-2*RInv[1,1]*RInv[2,1]:

expr18 := - RInv[4,36] - 4/3*RInv[1,1]*RInv[3,1]-1/4*RInv[2,1]*RInv[2,2]-3*RInv[4,1]+4*RInv[4,7]+RInv[4,5]-1/4*RInv[4,21]+3/4*RInv[1,1]^2*RInv[2,1]-3*RInv[1,1]*RInv[3,2]+1/4*RInv[1,1]*RInv[3,5]-1/12*RInv[1,1]^4-1/8*RInv[1,1]^2*RInv[2,2]+1/8*RInv[2,2]^2 - RInv[5,1] + 1/24*RInv[1,1]^5-5/6*RInv[1,1]^2*RInv[3,1]+5/8*RInv[1,1]*RInv[2,1]^2-5/4*RInv[1,1]*RInv[4,1]-5/12*RInv[1,1]^3*RInv[2,1]+5/6*RInv[2,1]*RInv[3,1]:

expr19 := - RInv[6,108] - 31/24*RInv[1,1]^3*RInv[3,1]-11/16*RInv[1,1]^4*RInv[2,1]+1/12*RInv[1,1]^6-7/8*RInv[1,1]^2*RInv[4,1]+7/16*RInv[1,1]^2*RInv[2,1]^2+1/8*RInv[1,1]^3*RInv[3,2]-RInv[1,1]*RInv[5,2]+1/2*RInv[6,47]+RInv[6,13]+RInv[3,1]^2-RInv[3,1]*RInv[3,2]+1/8*RInv[3,1]*RInv[3,5]+1/4*RInv[1,1]*RInv[2,1]*RInv[3,2]+3/2*RInv[1,1]*RInv[2,1]*RInv[3,1]-1/8*RInv[1,1]*RInv[2,2]*RInv[3,1]:

expr20 := -RInv[7,7490] + 1/64*RInv[1,1]*RInv[2,2]*RInv[4,21]+1/2*RInv[7,2190]-3/8*RInv[1,1]*RInv[2,2]*RInv[4,1]+1/12*RInv[2,1]*RInv[2,2]*RInv[3,1]-23/48*RInv[1,1]^2*RInv[2,2]*RInv[3,1]+3/8*RInv[1,1]*RInv[2,1]^2*RInv[2,2]-31/96*RInv[1,1]^3*RInv[2,1]*RInv[2,2]-1/2*RInv[1,1]*RInv[2,1]*RInv[4,1]-11/12*RInv[1,1]^2*RInv[2,1]*RInv[3,1]-1/16*RInv[1,1]*RInv[2,1]*RInv[2,2]^2-2*RInv[7,14]+1/192*RInv[1,1]^3*RInv[2,2]^2+5/12*RInv[1,1]^3*RInv[4,1]-1/3*RInv[3,1]*RInv[4,1]-11/288*RInv[1,1]^7-25/48*RInv[1,1]^3*RInv[2,1]^2+35/96*RInv[1,1]^5*RInv[2,1]+79/144*RInv[1,1]^4*RInv[3,1]+1/6*RInv[2,1]^2*RInv[3,1]-4/9*RInv[1,1]*RInv[3,1]^2+7/192*RInv[1,1]^5*RInv[2,2]-1/24*RInv[2,2]^2*RInv[3,1]-2*RInv[7,55]-1/192*RInv[1,1]^3*RInv[4,21]-2*RInv[1,1]*RInv[6,47]-3/4*RInv[1,1]^2*RInv[5,33]+1/2*RInv[3,2]*RInv[4,1]-1/6*RInv[1,1]^4*RInv[3,2]-1/4*RInv[2,1]^2*RInv[3,2]+1/4*RInv[1,1]^2*RInv[5,2]-1/3*RInv[3,1]*RInv[4,5]+1/6*RInv[1,1]^3*RInv[4,5]-3/4*RInv[1,1]^2*RInv[5,8]+1/24*RInv[3,1]*RInv[4,21]-3/4*RInv[2,2]*RInv[5,2]-1/2*RInv[1,1]*RInv[2,1]*RInv[4,5]+5/6*RInv[1,1]*RInv[3,1]*RInv[3,2]+1/2*RInv[1,1]^2*RInv[2,1]*RInv[3,2]+1/16*RInv[1,1]^2*RInv[2,2]*RInv[3,2]+1/4*RInv[2,2]*RInv[5,8]+1/16*RInv[2,2]^2*RInv[3,2]-2*RInv[1,1]*RInv[6,13]+RInv[2,1]*RInv[5,2]+1/4*RInv[2,2]*RInv[5,33]:

expr21 := -DualRInv[3,23] +1/2*DualRInv[3,13]+DualRInv[3,2]-3/8*RInv[1,1]*DualRInv[2,2]- DualRInv[4,2] - 1/2*RInv[1,1]*DualRInv[3,2]:

expr22 := - DualRInv[5,1770] + 5/32*RInv[1,1]^3*DualRInv[2,2]-9/8*RInv[1,1]*RInv[2,1]*DualRInv[2,2]+3/32*RInv[1,1]*RInv[2,2]*DualRInv[2,2]-RInv[3,1]*DualRInv[2,2]+3/4*RInv[3,2]*DualRInv[2,2]-1/16*RInv[3,5]*DualRInv[2,2] - DualRInv[5,1404] -1/8*RInv[2,2]*DualRInv[3,13]:

# signature dependent identities

expr23 := - RInv[5,123] + 5*sigma*DualRInv[2,2]*DualRInv[3,2]/24+5*sigma*DualRInv[2,2]*DualRInv[3,13]/48-2*RInv[1,1]^5/3+25*RInv[1,1]^3*RInv[2,1]/6+15*RInv[1,1]*RInv[2,1]^2/2-5*RInv[1,1]*RInv[2,1]*RInv[2,2]/2+15*RInv[1,1]^2*RInv[3,1]/2+10*RInv[2,1]*RInv[3,1]/3-5*RInv[2,2]*RInv[3,1]/6-5*RInv[1,1]^2*RInv[3,2]/2-10*RInv[2,1]*RInv[3,2]+5*RInv[2,2]*RInv[3,2]/2+5*RInv[1,1]^2*RInv[3,5]/12-5*RInv[2,1]*RInv[3,5]/6+5*RInv[2,2]*RInv[3,5]/12+5*RInv[1,1]*RInv[4,1]+20*RInv[5,8]+20*RInv[5,33]:

# WeylToRiemann and RiemannToWeyl

expr24 := Weyl[a,b,c,d]-Riemann[a,b,c,d]-1/2*g[a,d]*Ricci[b,c]-1/2*g[b,c]*Ricci[a,d]+1/2*g[a,c]*Ricci[b,d]+1/2*g[b,d]*Ricci[a,c]-1/6*RicciS[]*(g[a,c]*g[b,d]-g[a,d]*g[b,c]):

# RiemannToRicci

expr25 := Riemann[c,d,-c,-d]*Riemann[a,f,b,-f]*Riemann[-a,-b,h,l]*g[-h,-l]-RicciS[]*Ricci[a,b]*Riemann[-a,-b,h,l]*g[-h,-l]:

# InvToRiemann and RiemannToInv

expr26 := RInv[7,306]-Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,-i3,i4]*Riemann[-i2,i5,i6,i7]*Riemann[-i4,i8,i9,i10]*Riemann[-i5,a1,-i8,-a1]*Riemann[-i6,a4,-i9,a3]*Riemann[-i7,-a4,-i10,-a3]:

expr27 := RInv[1,1]*DualRInv[2,1]-(Riemann[i11,i22,-i11,-i22])*(Riemann[i1,i2,-i1,i3]*Riemann[-i2,i4,i5,i6]*epsilon[-i3,-i4,-i5,-i6]):

expr28 := DualRInv[2,3]^2-(Riemann[a1,a2,a4,a3]*Riemann[-a1,-a4,a6,a5]*epsilon[-a2,-a3,-a6,-a5])*(Riemann[a10,a20,a40,a30]*Riemann[-a10,-a40,a60,a50]*epsilon[-a20,-a30,-a60,-a50]):

expr29 := RInv[3,3]*DualRInv[5,2]-(Riemann[i10,i20,-i10,i30]*Riemann[-i20,i40,i50,i60]*Riemann[-i30,-i40,-i50,-i60])*(Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,-i3,i4]*Riemann[-i2,i5,-i5,i6]*Riemann[-i4,i7,i8,i9]*Riemann[-i7,i10,-i10,a1]*epsilon[-i6,-i8,-i9,-a1]):

expr30 := RInv[6,137]+2*DualRInv[5,289]-Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,-i3,i4]*Riemann[-i2,i5,i6,i7]*Riemann[-i4,i8,-i6,i9]*Riemann[-i5,-i8,i10,a1]*Riemann[-i7,-i10,-i9,-a1]-2*(Riemann[a2,i1,-a2,i2]*Riemann[-i1,i3,i4,i5]*Riemann[-i2,i6,-i4,i7]*Riemann[-i3,i8,-i7,i9]*Riemann[-i8,i10,-i10,a1]*epsilon[-i5,-i6,-i9,-a1]):


#
# All expr must return 0
#

settime := time():

Weyl := C:
Riemann := R:
Ricci := R:
RicciS := R:

for ii from 1 to 23 do 
  if RiemannSimplify(expr||ii)=0 then 
      lprint(ii=ok)
  else
      lprint(ii="error")
  end if;
od;

for ii from 24 to 24 do 
  if WeylToRiemann(expr||ii)=0 and 
     expand(RiemannToWeyl(expr||ii))=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

for ii from 25 to 25 do 
  if RiemannToRicci(expr||ii)=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

for ii from 26 to 30 do 
  if Canonical(InvToRiemann(expr||ii))=0 and 
     Canonical(RiemannToInv(expr||ii))=0 then 
      lprint(ii=ok) 
  else
      lprint(ii="error")
  end if;
od;

unassign(seq(evaln(expr||ii),ii=1..30));
 
lprint(time()-settime);

unassign('ii,settime');
